using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;


namespace Test_Filter
{
    public partial class Form1 : Form
    {
        DataTable table = new DataTable();
        DataColumn[] Columns = new DataColumn[4];

        public Form1()
        {
            InitializeComponent();
            Osvjezi();
            gridGroupingControl1.TableControlCurrentCellKeyDown += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlCurrentCellKeyDown);
        }

        void gridGroupingControl1_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            GridTableCellStyleInfo style = cc.Renderer.CurrentStyle as GridTableCellStyleInfo;

            if (style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.FilterBar && e.Inner.KeyData == Keys.Enter)
            {
                GridTableFilterBarCellRenderer crr = (GridTableFilterBarCellRenderer)cc.Renderer;
                if (crr != null)
                {
                    GridTableCellStyleInfo tableStyleInfo = e.TableControl.Model[cc.RowIndex, cc.ColIndex];
                    GridTableCellStyleInfoIdentity tableCellIdentity = tableStyleInfo.TableCellIdentity;
                    crr.Model.Select(tableCellIdentity, crr.ListBoxPart.SelectedIndex);
                    crr.SetTextBoxText(crr.GetFilterBarText(tableStyleInfo), false);
                    cc.MoveTo(cc.RowIndex, cc.ColIndex);
                }
            }

            if (style != null && style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.FilterBar && e.TableControl.CurrentCell.IsDroppedDown == false)
            {
                if (e.Inner.KeyData == Keys.Space)
                    cc.ShowDropDown();

                if (e.Inner.KeyData == Keys.Tab || e.Inner.KeyData == Keys.Right)
                {
                    cc.MoveTo(cc.RowIndex, cc.ColIndex + 1);
                }
                if (e.Inner.KeyData == Keys.Left)
                {
                    if (cc.ColIndex > 1)
                    {
                        cc.MoveTo(cc.RowIndex, cc.ColIndex - 1);
                    }
                }
                if (e.Inner.KeyData == Keys.Down)
                {
                    cc.MoveTo(cc.RowIndex + 1, cc.ColIndex);
                }            
            }

            if (e.Inner.KeyData == Keys.Up && style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord)
            {
                cc.MoveTo(cc.RowIndex -1, cc.ColIndex);
            }
        }



        public void Osvjezi()
        {
            GridColumnDescriptor gdc;
            
            for (int i = 0; i < 4; i++ )
            {
                gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
                Columns[i] = new DataColumn();
                Columns[i].ColumnName = i.ToString();
                gdc = new GridColumnDescriptor(Columns[i].ColumnName);
                gdc.HeaderText = "Filter Test";
                gdc.AllowFilter = true;
                table.Columns.Add(Columns[i]);
                gridGroupingControl1.TableDescriptor.Columns.Add(gdc);
                
            }


            for (int i = 0; i < table.Columns.Count; i++)
            {
                DataRow row = table.NewRow();
                for (int j = 0; j < 4; j++)
                {
                    if (i %2 == 0 &&  j%2 == 0)
                        row[j] = j.ToString();
                    else row[j] = i.ToString();
                }
                table.Rows.Add(row);
            }

            gridGroupingControl1.DataSource = table;
        }
    }
}